/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasCloudProviderSnapshotRestoreJobConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.9.0/docs/data-sources/cloud_provider_snapshot_restore_job#cluster_name DataMongodbatlasCloudProviderSnapshotRestoreJob#cluster_name}
    */
    readonly clusterName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.9.0/docs/data-sources/cloud_provider_snapshot_restore_job#id DataMongodbatlasCloudProviderSnapshotRestoreJob#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.9.0/docs/data-sources/cloud_provider_snapshot_restore_job#job_id DataMongodbatlasCloudProviderSnapshotRestoreJob#job_id}
    */
    readonly jobId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.9.0/docs/data-sources/cloud_provider_snapshot_restore_job#project_id DataMongodbatlasCloudProviderSnapshotRestoreJob#project_id}
    */
    readonly projectId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.9.0/docs/data-sources/cloud_provider_snapshot_restore_job mongodbatlas_cloud_provider_snapshot_restore_job}
*/
export declare class DataMongodbatlasCloudProviderSnapshotRestoreJob extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_cloud_provider_snapshot_restore_job";
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.9.0/docs/data-sources/cloud_provider_snapshot_restore_job mongodbatlas_cloud_provider_snapshot_restore_job} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasCloudProviderSnapshotRestoreJobConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasCloudProviderSnapshotRestoreJobConfig);
    get cancelled(): cdktf.IResolvable;
    private _clusterName?;
    get clusterName(): string;
    set clusterName(value: string);
    get clusterNameInput(): string | undefined;
    get createdAt(): string;
    get deliveryType(): string;
    get deliveryUrl(): string[];
    get expired(): cdktf.IResolvable;
    get expiresAt(): string;
    get finishedAt(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _jobId?;
    get jobId(): string;
    set jobId(value: string);
    get jobIdInput(): string | undefined;
    get oplogInc(): number;
    get oplogTs(): number;
    get pointInTimeUtcSeconds(): number;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    get snapshotId(): string;
    get targetClusterName(): string;
    get targetProjectId(): string;
    get timestamp(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
