/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
export * as accessListApiKey from './access-list-api-key';
export * as advancedCluster from './advanced-cluster';
export * as alertConfiguration from './alert-configuration';
export * as apiKey from './api-key';
export * as auditing from './auditing';
export * as backupCompliancePolicy from './backup-compliance-policy';
export * as cloudBackupSchedule from './cloud-backup-schedule';
export * as cloudBackupSnapshot from './cloud-backup-snapshot';
export * as cloudBackupSnapshotExportBucket from './cloud-backup-snapshot-export-bucket';
export * as cloudBackupSnapshotExportJob from './cloud-backup-snapshot-export-job';
export * as cloudBackupSnapshotRestoreJob from './cloud-backup-snapshot-restore-job';
export * as cloudProviderAccess from './cloud-provider-access';
export * as cloudProviderAccessAuthorization from './cloud-provider-access-authorization';
export * as cloudProviderAccessSetup from './cloud-provider-access-setup';
export * as cloudProviderSnapshot from './cloud-provider-snapshot';
export * as cloudProviderSnapshotBackupPolicy from './cloud-provider-snapshot-backup-policy';
export * as cloudProviderSnapshotRestoreJob from './cloud-provider-snapshot-restore-job';
export * as cluster from './cluster';
export * as customDbRole from './custom-db-role';
export * as customDnsConfigurationClusterAws from './custom-dns-configuration-cluster-aws';
export * as dataLake from './data-lake';
export * as databaseUser from './database-user';
export * as encryptionAtRest from './encryption-at-rest';
export * as eventTrigger from './event-trigger';
export * as federatedSettingsIdentityProvider from './federated-settings-identity-provider';
export * as federatedSettingsOrgConfig from './federated-settings-org-config';
export * as federatedSettingsOrgRoleMapping from './federated-settings-org-role-mapping';
export * as globalClusterConfig from './global-cluster-config';
export * as ldapConfiguration from './ldap-configuration';
export * as ldapVerify from './ldap-verify';
export * as maintenanceWindow from './maintenance-window';
export * as networkContainer from './network-container';
export * as networkPeering from './network-peering';
export * as onlineArchive from './online-archive';
export * as orgInvitation from './org-invitation';
export * as privateEndpointRegionalMode from './private-endpoint-regional-mode';
export * as privateIpMode from './private-ip-mode';
export * as privatelinkEndpoint from './privatelink-endpoint';
export * as privatelinkEndpointServerless from './privatelink-endpoint-serverless';
export * as privatelinkEndpointService from './privatelink-endpoint-service';
export * as privatelinkEndpointServiceAdl from './privatelink-endpoint-service-adl';
export * as privatelinkEndpointServiceServerless from './privatelink-endpoint-service-serverless';
export * as project from './project';
export * as projectApiKey from './project-api-key';
export * as projectInvitation from './project-invitation';
export * as projectIpAccessList from './project-ip-access-list';
export * as searchIndex from './search-index';
export * as serverlessInstance from './serverless-instance';
export * as team from './team';
export * as teams from './teams';
export * as thirdPartyIntegration from './third-party-integration';
export * as x509AuthenticationDatabaseUser from './x509-authentication-database-user';
export * as dataMongodbatlasAccessListApiKey from './data-mongodbatlas-access-list-api-key';
export * as dataMongodbatlasAccessListApiKeys from './data-mongodbatlas-access-list-api-keys';
export * as dataMongodbatlasAdvancedCluster from './data-mongodbatlas-advanced-cluster';
export * as dataMongodbatlasAdvancedClusters from './data-mongodbatlas-advanced-clusters';
export * as dataMongodbatlasAlertConfiguration from './data-mongodbatlas-alert-configuration';
export * as dataMongodbatlasAlertConfigurations from './data-mongodbatlas-alert-configurations';
export * as dataMongodbatlasApiKey from './data-mongodbatlas-api-key';
export * as dataMongodbatlasApiKeys from './data-mongodbatlas-api-keys';
export * as dataMongodbatlasAuditing from './data-mongodbatlas-auditing';
export * as dataMongodbatlasBackupCompliancePolicy from './data-mongodbatlas-backup-compliance-policy';
export * as dataMongodbatlasCloudBackupSchedule from './data-mongodbatlas-cloud-backup-schedule';
export * as dataMongodbatlasCloudBackupSnapshot from './data-mongodbatlas-cloud-backup-snapshot';
export * as dataMongodbatlasCloudBackupSnapshotExportBucket from './data-mongodbatlas-cloud-backup-snapshot-export-bucket';
export * as dataMongodbatlasCloudBackupSnapshotExportBuckets from './data-mongodbatlas-cloud-backup-snapshot-export-buckets';
export * as dataMongodbatlasCloudBackupSnapshotExportJob from './data-mongodbatlas-cloud-backup-snapshot-export-job';
export * as dataMongodbatlasCloudBackupSnapshotExportJobs from './data-mongodbatlas-cloud-backup-snapshot-export-jobs';
export * as dataMongodbatlasCloudBackupSnapshotRestoreJob from './data-mongodbatlas-cloud-backup-snapshot-restore-job';
export * as dataMongodbatlasCloudBackupSnapshotRestoreJobs from './data-mongodbatlas-cloud-backup-snapshot-restore-jobs';
export * as dataMongodbatlasCloudBackupSnapshots from './data-mongodbatlas-cloud-backup-snapshots';
export * as dataMongodbatlasCloudProviderAccess from './data-mongodbatlas-cloud-provider-access';
export * as dataMongodbatlasCloudProviderAccessSetup from './data-mongodbatlas-cloud-provider-access-setup';
export * as dataMongodbatlasCloudProviderSnapshot from './data-mongodbatlas-cloud-provider-snapshot';
export * as dataMongodbatlasCloudProviderSnapshotBackupPolicy from './data-mongodbatlas-cloud-provider-snapshot-backup-policy';
export * as dataMongodbatlasCloudProviderSnapshotRestoreJob from './data-mongodbatlas-cloud-provider-snapshot-restore-job';
export * as dataMongodbatlasCloudProviderSnapshotRestoreJobs from './data-mongodbatlas-cloud-provider-snapshot-restore-jobs';
export * as dataMongodbatlasCloudProviderSnapshots from './data-mongodbatlas-cloud-provider-snapshots';
export * as dataMongodbatlasCluster from './data-mongodbatlas-cluster';
export * as dataMongodbatlasClusters from './data-mongodbatlas-clusters';
export * as dataMongodbatlasCustomDbRole from './data-mongodbatlas-custom-db-role';
export * as dataMongodbatlasCustomDbRoles from './data-mongodbatlas-custom-db-roles';
export * as dataMongodbatlasCustomDnsConfigurationClusterAws from './data-mongodbatlas-custom-dns-configuration-cluster-aws';
export * as dataMongodbatlasDataLake from './data-mongodbatlas-data-lake';
export * as dataMongodbatlasDataLakes from './data-mongodbatlas-data-lakes';
export * as dataMongodbatlasDatabaseUser from './data-mongodbatlas-database-user';
export * as dataMongodbatlasDatabaseUsers from './data-mongodbatlas-database-users';
export * as dataMongodbatlasEventTrigger from './data-mongodbatlas-event-trigger';
export * as dataMongodbatlasEventTriggers from './data-mongodbatlas-event-triggers';
export * as dataMongodbatlasFederatedSettings from './data-mongodbatlas-federated-settings';
export * as dataMongodbatlasFederatedSettingsIdentityProvider from './data-mongodbatlas-federated-settings-identity-provider';
export * as dataMongodbatlasFederatedSettingsIdentityProviders from './data-mongodbatlas-federated-settings-identity-providers';
export * as dataMongodbatlasFederatedSettingsOrgConfig from './data-mongodbatlas-federated-settings-org-config';
export * as dataMongodbatlasFederatedSettingsOrgConfigs from './data-mongodbatlas-federated-settings-org-configs';
export * as dataMongodbatlasFederatedSettingsOrgRoleMapping from './data-mongodbatlas-federated-settings-org-role-mapping';
export * as dataMongodbatlasFederatedSettingsOrgRoleMappings from './data-mongodbatlas-federated-settings-org-role-mappings';
export * as dataMongodbatlasGlobalClusterConfig from './data-mongodbatlas-global-cluster-config';
export * as dataMongodbatlasLdapConfiguration from './data-mongodbatlas-ldap-configuration';
export * as dataMongodbatlasLdapVerify from './data-mongodbatlas-ldap-verify';
export * as dataMongodbatlasMaintenanceWindow from './data-mongodbatlas-maintenance-window';
export * as dataMongodbatlasNetworkContainer from './data-mongodbatlas-network-container';
export * as dataMongodbatlasNetworkContainers from './data-mongodbatlas-network-containers';
export * as dataMongodbatlasNetworkPeering from './data-mongodbatlas-network-peering';
export * as dataMongodbatlasNetworkPeerings from './data-mongodbatlas-network-peerings';
export * as dataMongodbatlasOnlineArchive from './data-mongodbatlas-online-archive';
export * as dataMongodbatlasOnlineArchives from './data-mongodbatlas-online-archives';
export * as dataMongodbatlasOrgInvitation from './data-mongodbatlas-org-invitation';
export * as dataMongodbatlasPrivateEndpointRegionalMode from './data-mongodbatlas-private-endpoint-regional-mode';
export * as dataMongodbatlasPrivatelinkEndpoint from './data-mongodbatlas-privatelink-endpoint';
export * as dataMongodbatlasPrivatelinkEndpointService from './data-mongodbatlas-privatelink-endpoint-service';
export * as dataMongodbatlasPrivatelinkEndpointServiceAdl from './data-mongodbatlas-privatelink-endpoint-service-adl';
export * as dataMongodbatlasPrivatelinkEndpointServiceServerless from './data-mongodbatlas-privatelink-endpoint-service-serverless';
export * as dataMongodbatlasPrivatelinkEndpointsServiceAdl from './data-mongodbatlas-privatelink-endpoints-service-adl';
export * as dataMongodbatlasPrivatelinkEndpointsServiceServerless from './data-mongodbatlas-privatelink-endpoints-service-serverless';
export * as dataMongodbatlasProject from './data-mongodbatlas-project';
export * as dataMongodbatlasProjectApiKey from './data-mongodbatlas-project-api-key';
export * as dataMongodbatlasProjectApiKeys from './data-mongodbatlas-project-api-keys';
export * as dataMongodbatlasProjectInvitation from './data-mongodbatlas-project-invitation';
export * as dataMongodbatlasProjectIpAccessList from './data-mongodbatlas-project-ip-access-list';
export * as dataMongodbatlasProjects from './data-mongodbatlas-projects';
export * as dataMongodbatlasRolesOrgId from './data-mongodbatlas-roles-org-id';
export * as dataMongodbatlasSearchIndex from './data-mongodbatlas-search-index';
export * as dataMongodbatlasSearchIndexes from './data-mongodbatlas-search-indexes';
export * as dataMongodbatlasServerlessInstance from './data-mongodbatlas-serverless-instance';
export * as dataMongodbatlasServerlessInstances from './data-mongodbatlas-serverless-instances';
export * as dataMongodbatlasTeam from './data-mongodbatlas-team';
export * as dataMongodbatlasTeams from './data-mongodbatlas-teams';
export * as dataMongodbatlasThirdPartyIntegration from './data-mongodbatlas-third-party-integration';
export * as dataMongodbatlasThirdPartyIntegrations from './data-mongodbatlas-third-party-integrations';
export * as dataMongodbatlasX509AuthenticationDatabaseUser from './data-mongodbatlas-x509-authentication-database-user';
export * as provider from './provider';
